Index: /anuga_work/production/busselton/export_results_all.py
===================================================================
--- /anuga_work/production/busselton/export_results_all.py	(revision 5431)
+++ /anuga_work/production/busselton/export_results_all.py	(revision 5431)
@@ -0,0 +1,97 @@
+import project, os
+import sys
+
+from anuga.shallow_water.data_manager import sww2dem
+from os import sep
+
+
+time_dir = '20080619_092128_run_trial_0.6_exmouth_current_kvanputt'
+
+
+
+cellsize = 10
+#cellsize = 150
+timestep = 0
+directory = project.output_dir
+name = directory+'test'+sep+time_dir+sep+project.scenario_name # test folder take out!!
+
+from anuga.shallow_water.data_manager import convert_dem_from_ascii2netcdf, dem2pts
+
+
+is_parallel = False
+#is_parallel = True
+
+if is_parallel == True: nodes = 4
+print 'output dir:', name
+
+area = ['Busselton', 'Bunbury']
+
+for which_area in area:
+    if which_area == 'Busselton':
+        easting_min = project.xminBusselton
+        easting_max = project.xmaxBusselton
+        northing_min = project.yminBusselton
+        northing_max = project.ymaxBusselton
+
+    if which_area == 'Bunbury':
+        easting_min = project.xminBunbury
+        easting_max = project.xmaxBunbury
+        northing_min = project.yminBunbury
+        northing_max = project.ymaxBunbury
+
+   # var = [2,3,4] # depth and speed
+#var = [2] # depth
+    var = [0,4]
+
+    for which_var in var:
+        if which_var == 0:  # Stage
+            outname = name + which_area + '_stage' 
+            quantityname = 'stage'
+
+        if which_var == 1:  # Absolute Momentum
+            outname = name + which_area + '_momentum' 
+            quantityname = '(xmomentum**2 + ymomentum**2)**0.5'  
+
+        if which_var == 2:  # Depth
+            outname = name + which_area + '_depth'
+            quantityname = 'stage-elevation'  
+
+        if which_var == 3:  # Speed
+            outname = name + which_area + '_speed'
+            quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6/(stage-elevation))'  #Speed
+
+        if which_var == 4:  # Elevation
+            outname = name + which_area + '_elevation'
+            quantityname = 'elevation'  #Elevation
+
+        if is_parallel == True:
+        #    print 'is_parallel',is_parallel
+            for i in range(0,nodes):
+                namei = name + '_P%d_%d' %(i,nodes)
+                outnamei = outname + '_P%d_%d' %(i,nodes)
+                print 'start sww2dem for sww file %d' %(i)
+                sww2dem(namei, basename_out = outnamei,
+                            quantity = quantityname,
+                            #timestep = timestep,
+                            cellsize = cellsize,      
+                            easting_min = project_grad.e_min_area,
+                            easting_max = project_grad.e_max_area,
+                            northing_min = project_grad.n_min_area,
+                            northing_max = project_grad.n_max_area,        
+                            reduction = max, 
+                            verbose = True,
+                            format = 'asc')
+        else:
+            print 'start sww2dem',which_area, easting_min,name,outname
+            sww2dem(name, basename_out = outname,
+                        quantity = quantityname,
+                        timestep = timestep,
+                        cellsize = cellsize,      
+                        easting_min = easting_min,
+                        easting_max = easting_max,
+                        northing_min = northing_min,
+                        northing_max = northing_max,        
+                        reduction = max, 
+                        verbose = True,
+                        format = 'asc')
+
Index: /anuga_work/production/perth/get_timeseries.py
===================================================================
--- /anuga_work/production/perth/get_timeseries.py	(revision 5431)
+++ /anuga_work/production/perth/get_timeseries.py	(revision 5431)
@@ -0,0 +1,30 @@
+"""
+Generate time series of nominated "gauges" read from project.gauge_filename. This 
+is done by first running sww2csv_gauges on two different directories to make 
+'csv' files. Then running csv2timeseries_graphs detailing the two directories 
+containing the csv file and produces one set of graphs in the 'output_dir' containing
+the details at the gauges for both these sww files.
+
+Note, this script will only work if pylab is installed on the platform
+
+"""
+
+from os import sep
+from anuga.abstract_2d_finite_volumes.util import sww2csv_gauges,csv2timeseries_graphs
+
+import project
+
+
+timestamp='20080619_115643_run_trial_0.6_exmouth_kvanputt'
+
+filename=project.output_dir+timestamp+sep+project.scenario_name+'.sww'
+print 'Hello', filename
+
+sww2csv_gauges(filename,
+                project.gauges_dir_name,
+                quantities = ['stage','speed','depth','elevation'],
+                verbose=True)
+                
+
+    
+