Index: /anuga_work/development/boxingday08/project.py
===================================================================
--- /anuga_work/development/boxingday08/project.py	(revision 5457)
+++ /anuga_work/development/boxingday08/project.py	(revision 5458)
@@ -77,10 +77,15 @@
 #read in polyline boundary
 from anuga.shallow_water.data_manager import urs2sts,create_sts_boundary
-base_name='polyline'
+urs_name='polyline'
+#base_name=urs_name
+tide=0.35
+base_name='tide_polyline'
+#base_name='most_polyline'
 import os
 if os.path.exists(base_name+'.sts'):
-	print 'sts boundary file already created.'
+    print 'sts boundary file already created.'
 else:
-	urs2sts(base_name,mean_stage=0.0,verbose=False)
+    print 'creatin sts file'
+    urs2sts(urs_name,base_name,mean_stage=tide,verbose=False)
 
 order_filename='sts_order.txt'
@@ -118,5 +123,6 @@
 mesh_elevname = 'phuket_mesh_elev'
 boundary_most_in = dir+sep+'out'
-boundary_most_out = dir+sep+'most_boundary_condition'
+#boundary_most_out = dir+sep+'most_boundary_condition'
+boundary_most_out = dir+sep+'tide_most_boundary_condition'
 
 dir='mesh_polygons'
@@ -140,4 +146,6 @@
     from pylab import plot,show,hold
     bounding_polygon=ensure_numeric(bounding_polygon)#for plotting only
+    #boundary=ensure_numeric(boundary)
+    #plot(boundary[:,0],boundary[:,1],'o')
     plot(bounding_polygon[:,0],bounding_polygon[:,1],'o')
     plot(bounding_polygon[:,0],bounding_polygon[:,1])
Index: /anuga_work/development/boxingday08/run_boxingday_most.py
===================================================================
--- /anuga_work/development/boxingday08/run_boxingday_most.py	(revision 5457)
+++ /anuga_work/development/boxingday08/run_boxingday_most.py	(revision 5458)
@@ -143,5 +143,5 @@
 #------------------------------------------------------------------------------
      
-tide = 0.0
+tide = 0.35
 domain.set_quantity('stage', tide)
 domain.set_quantity('friction', 0.01) 
@@ -187,5 +187,5 @@
            'origin': domain.geo_reference.get_origin(),
            'mean_stage': tide,
-           'zscale': 1,                 #Enhance tsunami
+           'zscale': 1.0,                 #Enhance tsunami
            'fail_on_NaN': False,
            'inverted_bathymetry': True},
@@ -195,10 +195,10 @@
 
 print 'Available boundary tags', domain.get_boundary_tags()
-#Bf = File_boundary(project.boundary_most_out+'.sww', 
-#                    domain, time_thinning=1, use_cache=True,verbose = True)
+Bf = File_boundary(project.boundary_most_out+'.sww', 
+                    domain, time_thinning=1, use_cache=True,verbose = True)
 Br = Reflective_boundary(domain)
 Bd = Dirichlet_boundary([tide,0.0,0.0])
 
-domain.set_boundary({'ocean': Bd,
+domain.set_boundary({'ocean': Bf,
                      'otherocean': Bd,
                      'land': Br,
Index: /anuga_work/development/boxingday08/run_boxingday_polyline.py
===================================================================
--- /anuga_work/development/boxingday08/run_boxingday_polyline.py	(revision 5457)
+++ /anuga_work/development/boxingday08/run_boxingday_polyline.py	(revision 5458)
@@ -46,6 +46,6 @@
 #------------------------------------------------------------------------------
 
-#scenario = 'poor_simulation'
-scenario = 'good_simulation'
+scenario = 'poor_simulation'
+#scenario = 'good_simulation'
 
 if os.access(scenario, os.F_OK) == 0:
@@ -92,4 +92,5 @@
 
 from Numeric import arange,allclose
+#This needs to be done by the user. Not easy at the moment
 boundary_tags={'ocean': arange(0,41).tolist(), 'otherocean': [41,44], 'land': [42,43]}
 
@@ -145,5 +146,5 @@
 #------------------------------------------------------------------------------
      
-tide = 0.0
+tide = 0.35
 domain.set_quantity('stage', tide)
 domain.set_quantity('friction', 0.01) 
@@ -165,5 +166,4 @@
 # Setup boundary conditions
 #------------------------------------------------------------------------------
-boundary_urs_in='data/boxing'
 boundary_urs_out=project.base_name
 