Index: /anuga_validation/circular_island/simple_circular/circular.py
===================================================================
--- /anuga_validation/circular_island/simple_circular/circular.py	(revision 5459)
+++ /anuga_validation/circular_island/simple_circular/circular.py	(revision 5460)
@@ -17,6 +17,48 @@
 
 #------------------------------------------------------------------------------
+# Project file
+#------------------------------------------------------------------------------
+#Set up file structure
+anuga_dir = home+'anuga_validation'+sep+'circular_island_tsunami_benchmark'+sep+'anuga'+sep
+meshes_dir = anuga_dir+'meshes'+sep
+meshname = 'circular_mesh.msh'
+output_dir = anuga_dir+'output'+sep
+
+
+##    #------------------------------------------------------------------------------
+##    # Copy scripts to time stamped output directory and capture screen
+##    # output to file
+##    #------------------------------------------------------------------------------
+##    print "Processor Name:",get_processor_name()
+##
+##    #copy script must be before screen_catcher
+##    #print kwargs
+##
+##    print 'output_dir', output_dir
+##    if myid == 0:
+##        copy_code_files(kwargs['output_dir'],__file__, 
+##                 dirname(project.__file__)+sep+ project.__name__+'.py' )
+##
+##        store_parameters(**kwargs)
+##
+##    barrier()
+##
+##    start_screen_catcher(kwargs['output_dir'], myid, numprocs)
+##
+##    print "Processor Name:",get_processor_name()
+##
+##    # filenames
+###    meshes_dir_name = project.meshes_dir_name+'.msh'
+##
+##    # creates copy of code in output dir
+##    print 'min triangles', project.trigs_min,
+##    print 'Note: This is generally about 20% less than the final amount'
+
+
+#------------------------------------------------------------------------------
 # Setup computational domain
 #------------------------------------------------------------------------------
+
+
 length = 30.
 width = 25.
@@ -28,5 +70,5 @@
 #boundary
 poly_domain = [[0,0],[length,0],[length,width],[0,width]]
-meshname = 'test.msh'
+
 
 # exporting asc grid
@@ -46,4 +88,7 @@
 
 #Create mesh
+
+print 'start create mesh from regions'
+ 
 create_mesh_from_regions(poly_domain,
                          boundary_tags={'wavemaker': [0], 'right': [1],
@@ -53,9 +98,15 @@
                          interior_regions = interior_dome,
                          use_cache=False,
-                         verbose=True)
+                         verbose=False)
 
-domain = Domain(meshname, use_cache=False, verbose = True)
+# Setup computational domain
+
+domain = Domain(meshes_dir+sep+meshname, use_cache=False, verbose = True)
 domain.set_name('circular')                  # Output name
-print domain.statistics()
+print 'memory usage before del domain',mem_usage()
+       
+    print domain.statistics()
+    print 'triangles',len(domain)
+
 
 #------------------------------------------------------------------------------
@@ -106,4 +157,5 @@
 Bw = Dirichlet_boundary([water_depth, 0, 0])          #wall
 Bt = Transmissive_Momentum_Set_Stage_boundary(domain, wave_form) #wavemaker
+
 domain.set_boundary({'left': Bw, 'right': Bw, 'top': Bw, 'wavemaker': Bt})
 
Index: /anuga_work/production/busselton/run_busselton.py
===================================================================
--- /anuga_work/production/busselton/run_busselton.py	(revision 5459)
+++ /anuga_work/production/busselton/run_busselton.py	(revision 5460)
@@ -171,5 +171,5 @@
     Br = Reflective_boundary(domain)
     Bd = Dirichlet_boundary([kwargs['tide'],0,0])
-    Bo = Dirichlet_boundary([kwargs['tide']+10.0,0,0]) # To be deleted for FESA runs
+    Bw = Dirichlet_boundary([kwargs['tide']+10.0,0,0]) # To be deleted for FESA runs
 
     Bf = Field_boundary(kwargs['boundary_file'],
@@ -197,5 +197,5 @@
         # To be deleted for FESA runs
         if allclose(t, 240):
-            domain.set_boundary({'back': Br, 'side': Bd, 'ocean': Bo})
+            domain.set_boundary({'back': Br, 'side': Bd, 'ocean': Bw})
 
         if allclose(t, 1440):